
#include "LCD_2x16_CD4094.h"

#define DATA_PIN  RD0_bit   // Data input (DSA and DSB connected together)
#define CLK_PIN   RD1_bit   //  Clock input
#define EN_PIN    RD2_bit   //  Enable

short RS;

void LCD_Initialize(void){
  RS = 0;
  delay_ms(20);
  LCD_Command(3);
  delay_us(500);
  LCD_Command(3);
  delay_us(500);
  LCD_Command(3);
  delay_us(500);
  LCD_Command(LCD_RETURN_HOME);
  delay_ms(1);
  LCD_Command(LCD_START);
  delay_ms(5);
  LCD_Command(display_on);
  delay_ms(5);
  LCD_Command(cursor_direction_inc);
  delay_ms(5);
  LCD_Command(display_on);
  delay_ms(5);
}

void lCD_Nibble(char num){

  char i=0, j=0;
  
  CLK_PIN=0;
  EN_PIN=0;
  
  for( j = 8; j > 0; j =( j >> 1)){

    if(num & j)  {
    DATA_PIN=1;
   }
    else {
    DATA_PIN=0;
    }
    Delay_us(10);
    CLK_PIN=1;
    Delay_us(10);
    CLK_PIN=0;
}
  if(RS) DATA_PIN=1;
  else  DATA_PIN=0;

  for(i = 0; i < 2; i++){
    Delay_us(10);
    CLK_PIN=1;
    Delay_us(10);
    CLK_PIN=0;
  }
  EN_PIN=1;
  delay_us(2);
  EN_PIN=0;
}

void LCD_Chr(char LCD_Char){
  RS = 1;
  lCD_Nibble(LCD_Char >> 4);
  delay_us(10);
  lCD_Nibble(LCD_Char & 0x0F);
}

void LCD_Command(char _Cmd){
  RS = 0;
  lCD_Nibble(_Cmd >> 4);
  lCD_Nibble(_Cmd & 0x0F);
  if((_Cmd == 0x0C) || (_Cmd == 0x01) || (_Cmd == 0x0E) || (_Cmd == 0x0F)
  || (_Cmd == 0x10) || (_Cmd == 0x1E) || (_Cmd == 0x18) || (_Cmd == 0x08)
  || (_Cmd == 0x14) || (_Cmd == 0x02))
    Delay_ms(50);
}

void LCD_Write_Char(char row, char y, char LCD_Char){

  switch(row){
    case 1:
      LCD_Command(0x80 + y-1);
      break;
    case 2:
      LCD_Command(0xC0 + y-1);
      break;
    case 3:
      LCD_Command(0x94 + y-1);
      break;
    case 4:
      LCD_Command(0xD4 + y-1);
    break;
  }
    LCD_Chr (LCD_Char);
}

void LCD_Write_String(char row, char y, char *str)  // Send string to LCD function
{

    switch(row){
    case 1:
      LCD_Command(0x80 + y-1);
      break;
    case 2:
      LCD_Command(0xC0 + y-1);
      break;
    case 3:
      LCD_Command(0x94 + y-1);
      break;
    case 4:
      LCD_Command(0xD4 + y-1);
    break;
  }

  while(*str)              // Write data to LCD up to null
 {
     LCD_Chr(*str);
     str++;               // Increment buffer
  }
}